( Управление памятью.
  Системо-зависимые слова.
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
  Ревизия - сентябрь 1999
)

USER THREAD-HEAP   \ ÈÜÎÄÌ ÈÉÐÁ ÔÅËÕÝÅÇÏ ÐÏÔÏËÁ

\ VARIABLE USER-OFFS \ ÓÍÅÝÅÎÉÅ × ÏÂÌÁÓÔÉ ÄÁÎÎÙÈ ÐÏÔÏËÁ, 
                   \ ÇÄÅ ÓÏÚÄÁÀÔÓÑ ÎÏ×ÙÅ ÐÅÒÅÍÅÎÎÙÅ
(*
: ERR
  IF 0 ELSE GetLastError THEN
;  *)

: USER-ALLOT ( n -- )
  USER-OFFS +!

\ ×ÙÒÏ×ÎÑÅÍ × USER-CREATE _day 
\  USER-OFFS @ +   \ Ó ÎÁÞÁÌÁ ÐÒÉÂÁ×ÌÑÅÍ
\  CELL 1- +  [ CELL NEGATE ] LITERAL AND \ ÐÏÔÏÍ ×ÙÒÁ×ÎÉ×ÁÅÍ
\  USER-OFFS !
;

: USER-HERE ( -- n )
  USER-OFFS @
;

: ALLOCATE ( u -- a-addr ior ) \ 94 MEMORY
\ Распределить u байт непрерывного пространства данных. Указатель пространства 
\ данных не изменяется этой операцией. Первоначальное содержимое выделенного 
\ участка памяти неопределено.
\ Если распределение успешно, a-addr - выровненный адрес начала распределенной 
\ области и ior ноль.
\ Если операция не прошла, a-addr не представляет правильный адрес и ior - 
\ зависящий от реализации код ввода-вывода.
  DUP >R malloc
  DUP IF 0 ELSE -300 THEN
  RDROP
;

: FREE ( a-addr -- ior ) \ 94 MEMORY
  DUP >R free DROP FALSE
  RDROP
;

: RESIZE ( a-addr1 u -- a-addr2 ior ) \ 94 MEMORY
\ Вернуть непрерывную область пространства данных, индицируемую a-addr, системе 
\ для дальнейшего распределения. a-addr должен индицировать область 
\ пространства данных, которая ранее была получена по ALLOCATE или RESIZE.
\ Указатель пространства данных не изменяется данной операцией.
\ Если операция успешна, ior ноль. Если операция не прошла, ior - зависящий от 
\ реализации код ввода-вывода.
  >R DUP >R realloc
  DUP IF 0 ELSE -300 THEN
  2RDROP
;


